<?php

namespace Litecms\Task\Repositories\Presenter;

use League\Fractal\TransformerAbstract;
use Hashids;

class TaskTransformer extends TransformerAbstract
{
    public function transform(\Litecms\Task\Models\Task $task)
    {
        return [
            'id'                => $task->getRouteKey(),
            'key'               => [
                'public'    => $task->getPublicKey(),
                'route'     => $task->getRouteKey(),
            ], 
            'title'             => $task->title,
            'url'               => [
                'public'    => trans_url('task/'.$task->getPublicKey()),
                'user'      => guard_url('task/task/'.$task->getRouteKey()),
            ], 
            'status'            => trans('app.'.$task->status),
            'created_at'        => format_date($task->created_at),
            'updated_at'        => format_date($task->updated_at),
        ];
    }
}