<?php

namespace Litecms\Task;

use User;

class Task
{
    /**
     * $task object.
     */
    protected $task;

    /**
     * Constructor.
     */
    public function __construct(\Litecms\Task\Interfaces\TaskRepositoryInterface $task)
    {
        $this->task = $task;
    }

    /**
     * Returns count of task.
     *
     * @param array $filter
     *
     * @return int
     */
    public function count()
    {
        return  0;
    }

    /**
     * Make gadget View
     *
     * @param string $view
     *
     * @param int $count
     *
     * @return View
     */
    public function gadget($view = 'admin.task.gadget', $count = 10)
    {

        if (User::hasRole('user')) {
            $this->task->pushCriteria(new \Litepie\Litecms\Repositories\Criteria\TaskUserCriteria());
        }

        $task = $this->task->scopeQuery(function ($query) use ($count) {
            return $query->orderBy('id', 'DESC')->take($count);
        })->all();

        return view('task::' . $view, compact('task'))->render();
    }
}
